(* ::Package:: *)

%2 D BDM implementation of method as described in:
% A Decomposition Method for Global Evaluation of Shannon Entropy and Local Estimations of Algorithmic Complexity
% By Hector Zenil, Santiago Hern\[AAcute]ndez-Orozco, Narsis A. Kiani, Fernando Soler-Toscano, Antonio Rueda-Toicen
% preprint available at https://arxiv.org/abs/1609.00110

function b = bdm(SS)

% read complexities

squares = fscanf(fopen('complexities.txt','r'),'% f');

% vector to collect occurrencies
freqs = zeros(size(squares));
% indicate if there is some square
exist = zeros(size(squares));
[rows cols] = size(SS);

for i=1:4:(rows-3)
    for j=1:4:(cols-3)
        m = SS(i:i+3,j:j+3); % matrix
        n = bin2dec(num2str(m (:)'))+1;
        freqs(n)=freqs(n)+1;        
        exist(n)=1;
    end
end

b = sum(exist .* squares) + sum(log (nonzeros(freqs))/log(2));
